# About this app

## Motivation

This app started as a hobby project, since i am interested in testing out Linux phones as a daily driver and found it difficult to use,
because most of my online accounts are protected by long and complicated passwords stored in my Vaultwarden instance.
Since Bitwarden itself as a company has other priorities right now than to provide a mobile Linux client, i tried to build one on my own.

## Name

Bitritter is a combination of Bitwarden, which the client aims to be compatilble with and the german word Ritter, which means knight.

## Installation

Right now the only way to install is to clone this repository and compile it yourself.
Usually it can be done via
``` shell
  cargo build --release
```
with `cargo` installed (usually via `rustup`).
A binary named `bitritter` should then appear in the `target/release/` directory.
## Usage
Since, not all features (like account creation) are implemented in the UI yet, you have to create a =credentials.toml= in your root folder. 
There is a =credentials-example.toml= in this repository where you can see the structure of it. Feel free to copy and edit the example to your needs.
Only one account is supported at the moment, multi-account usage is on the feature list.

Right now - until more features are implemented like a password dialog - you have to use the buttons in the top bar to fetch and decrypt your data.
Press Login - Sync - Unlock in this order (if your credentials are set up correctly).
After this is done, the data is persisted encrypted in your working directory. The "Load" button will retrieve and decrypt it from there so you do not have to repeat the steps above.

## State

This app is still in a very early stage of development, but i wanted to upload my work, because there were several people interested in seeing
it and maybe even contributing to it. Release early, release often, eh?

### Feature list
- [x] Login to a server
- [x] Sync your vault
- [x] Unlock the vault
- [ ] Look at Entry details

#### Personal Vault
- [x] Decrypt usnernames
- [x] Decrpyt passwords
- [x] Copy passwords
- [ ] TOTP

#### Organisation Vault

# Alternatives
After my first proof of concept, i got informed about [Goldwarden](https://github.com/quexten/goldwarden), which has similar goals. 
I think it is more feature complete right now, so maybe it is interesting for you aswell.

# Contributing
Please refrain from opening issues about lacking features, since i got many topics on my list already.
PRs for improving my coding style are welcome, but please do not rewrite the whole code...
If there are bugs right now, you can open an issue, but since the app is quite unstable, i am not sure they get addressed
very soon. I hope that can change if i can get the basic features stabilized.

